#!/usr/bin/python
import sys
import os
import time
import getopt
import socket
import ConfigParser
import struct
import binascii
from pymodbus.constants import Endian
from pymodbus.payload import BinaryPayloadDecoder
from pymodbus.payload import BinaryPayloadBuilder
from pymodbus.client.sync import ModbusTcpClient

debug = str(sys.argv[1])
named_tuple = time.localtime() # get struct_time
time_string = time.strftime("%m/%d/%Y, %H:%M:%S inf wm", named_tuple) 
# tobi
ipaddress = 'XXX.XXX.X.X'
client = ModbusTcpClient(ipaddress, port=502)
rr= client.read_input_registers(4122,2,unit=1)
raw = struct.pack('>HH', rr.getRegister(1), rr.getRegister(0))
# ('04/10/2020, 13:09:20 inf wm', ' start 4122', [52129, 16512])
# 4024.85704422
lkw= float(struct.unpack('>f', raw)[0])
#print(time_string, ' start 4122', rr.registers)
totalw =  int(lkw * 1000)
#print('total kwatt aus wm',lkw)
#print('total watt fuer openwb',totalw)
f = open('/var/www/html/openWB/ramdisk/wattbezug', 'r')
inputop=int(f.read())
#print(inputop)
lkwneu=float(inputop)
lkwneu=lkwneu/1000
f.close()
if lkwneu < 0:
   lkwneu = lkwneu * -1
else:
   lkwneu = 0
#print(' pv ueberschuss',lkwneu)
builder = BinaryPayloadBuilder(byteorder=Endian.Big,
wordorder=Endian.Little)
builder.add_32bit_float(  lkwneu )
payload = builder.to_registers()

#print("-" * 60)
#print("Writing Registers")
#print("-" * 60)
#print(payload)
#print("\n")
regnew = builder.to_registers()
#print(' bew', regnew)
client.write_registers(74, regnew, unit=1)
print(totalw)
